SystemOrganization addCategory: #MaxClub!

Object subclass: #MaxClub
	instanceVariableNames: 'members evaluator maximum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MaxClub'!

!MaxClub commentStamp: 'hjo 3/17/2008 13:27' prior: 0!
If you want a MinClub, then just negate the value of evaluator block.!

!MaxClub classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 13:36'!
forNumbers

	^self new evaluator: [:number | number ]! !

!MaxClub methodsFor: 'accessing' stamp: 'hjo 3/17/2008 13:28'!
evaluator: monoBlock

	evaluator := monoBlock! !

!MaxClub methodsFor: 'testing' stamp: 'hjo 3/27/2008 11:10'!
isEmpty
	^self members isEmpty! !

!MaxClub methodsFor: 'accessing' stamp: 'hjo 3/17/2008 13:28'!
maximum

	^maximum! !

!MaxClub methodsFor: 'accessing' stamp: 'hjo 3/17/2008 13:28'!
maximum: aNumber

	members := nil.	
	maximum := aNumber! !

!MaxClub methodsFor: 'testing' stamp: 'hjo 3/27/2008 10:57'!
mayAccept: anObject

	^maximum isNil or: [ (evaluator value: anObject) >= maximum ]! !

!MaxClub methodsFor: 'accessing' stamp: 'hjo 3/17/2008 13:29'!
members

	members isNil ifTrue: [members := OrderedCollection new].
	^members! !

!MaxClub methodsFor: 'adding' stamp: 'hjo 3/17/2008 13:30'!
put: anObject

	"Answers boolean, if anObject is acceptted by me"
	| value |
	value := evaluator value: anObject.
	(self maximum isNil or: [value > self maximum]) 
		ifTrue: [ self setMaximum: value member: anObject. ^true ].
	value < self maximum
		ifTrue: [ ^false ].
	value = self maximum
		ifTrue: [ self members add: anObject. ^true ].
	self error: 'No one can reach here.'! !

!MaxClub methodsFor: 'adding' stamp: 'hjo 3/17/2008 13:30'!
putAll: aCollection

	aCollection do: [:object| self put: object ]! !

!MaxClub methodsFor: 'private' stamp: 'hjo 3/17/2008 13:31'!
setMaximum: aNumber member: anObject

	self maximum: aNumber.
	self members add: anObject! !

Object subclass: #MinClub
	instanceVariableNames: 'maxClub'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MaxClub'!

!MinClub classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/2/2008 11:05'!
forNumbers

	^self new evaluator: [:number | number ]! !

!MinClub methodsFor: 'as yet unclassified' stamp: 'hjo 9/2/2008 11:08'!
evaluator: aBlockContext 

	self maxClub evaluator: [:object | (aBlockContext value: object) negated ]! !

!MinClub methodsFor: 'testing' stamp: 'hjo 9/2/2008 11:23'!
isEmpty

	^self maxClub isEmpty! !

!MinClub methodsFor: 'private' stamp: 'hjo 9/2/2008 11:07'!
maxClub

	maxClub isNil ifTrue: [
		self maxClub: MaxClub new
	].
	^maxClub! !

!MinClub methodsFor: 'private' stamp: 'hjo 9/2/2008 11:08'!
maxClub: aMaxClub 

	maxClub := aMaxClub! !

!MinClub methodsFor: 'testing' stamp: 'hjo 9/2/2008 11:25'!
mayAccept: anObject

	^self maxClub mayAccept: anObject
! !

!MinClub methodsFor: 'accessing' stamp: 'hjo 9/2/2008 11:09'!
members

	^self maxClub members! !

!MinClub methodsFor: 'accessing' stamp: 'hjo 9/2/2008 11:14'!
minimum

	self maxClub maximum ifNil: [^nil].
	^self maxClub maximum negated! !

!MinClub methodsFor: 'as yet unclassified' stamp: 'hjo 9/2/2008 11:15'!
put: anObject 

	^self maxClub put: anObject! !

!MinClub methodsFor: 'as yet unclassified' stamp: 'hjo 9/3/2008 12:01'!
putAll: anArray 

	self maxClub putAll: anArray! !

TestCase subclass: #MaxClubTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MaxClub'!

!MaxClubTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 13:33'!
testForNumbers

	|mc|
	mc := MaxClub forNumbers.
	self assert: mc members size = 0.
	self assert: mc maximum = nil.
	#(
		(5 true 1 5)
		(5 true 2 5)
		(3 false 2 5)	
		(7 true 1 7)
	)
		do: [:array| |stream| stream := array readStream.
			self assert: (mc put: stream next) = stream next.
			self assert: mc members size = stream next.
			self assert: mc maximum = stream next.
		]! !

!MaxClubTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 13:33'!
testForOddCounting

	|mc|
	mc := MaxClub new.
	mc evaluator: [:x| (x select: [:each| each odd]) size ].
	self assert: mc members size = 0.
	self assert: mc maximum = nil.
	#(
		((2 4) true 1 0)
		((1 2 4) true 1 1)
		((1 2 4) true 2 1)
		((1 2 3 4) true 1 2)
		((0 2 3 4) false 1 2)
	)
		do: [:array| |stream| stream := array readStream.
			self assert: (mc put: stream next) = stream next.
			self assert: mc members size = stream next.
			self assert: mc maximum = stream next.
		]
! !

TestCase subclass: #MinClubTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MaxClub'!

!MinClubTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/2/2008 11:00'!
testForNumbers

	|mc|
	mc := MinClub forNumbers.
	self assert: mc members size = 0.
	self assert: mc minimum = nil.
	#(
		(5 true 1 5)
		(5 true 2 5)
		(3 true 1 3)	
		(7 false 1 3)
	)
		do: [:array| |stream| stream := array readStream.
			self assert: (mc put: stream next) = stream next.
			self assert: mc members size = stream next.
			self assert: mc minimum = stream next.
		]! !

!MinClubTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/2/2008 11:19'!
testForOddCounting

	|mc|
	mc := MinClub new.
	mc evaluator: [:x| (x select: [:each| each odd]) size ].
	self assert: mc members size = 0.
	self assert: mc minimum = nil.
	#(
		((1 3 5) true 1 3)
		((3 7 5) true 2 3)
		((1 2 4) true 1 1)
		((1 2 3 8) false 1 1)
		((0 2 4) true 1 0)
	)
		do: [:array| |stream| stream := array readStream.
			self assert: (mc put: stream next) = stream next.
			self assert: mc members size = stream next.
			self assert: mc minimum = stream next.
		]
! !

!MinClubTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/2/2008 11:22'!
testIsEmpty

	| mc |
	mc := MinClub forNumbers.
	self assert: mc isEmpty.
	mc put: 3.
	self deny: mc isEmpty! !

!MinClubTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/2/2008 11:27'!
testMayAccept

	| mc |
	mc := MinClub forNumbers.
	self assert: (mc mayAccept: 3).
	mc put: 3.
	self assert: (mc mayAccept: 3).
	mc put: 2.
	self deny: (mc mayAccept: 3).! !

!MinClubTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/2/2008 11:29'!
testPutAll

	| mc |
	mc := MinClub forNumbers.
	mc putAll: #(1 2 3 1 4 5).
	self assert: mc members size = 2.
	self assert: mc minimum = 1! !
